package explorviz.live_trace_processing.filter.counting;

import explorviz.live_trace_processing.filter.AbstractFilter;
import explorviz.live_trace_processing.filter.IPipeReceiver;
import explorviz.live_trace_processing.record.IRecord;
import explorviz.live_trace_processing.record.event.AbstractBeforeEventRecord;
import explorviz.live_trace_processing.record.event.AbstractEventRecord;
import explorviz.live_trace_processing.record.trace.Trace;

public class RecordCountingFilter extends AbstractFilter implements IRecordCounting {

	public RecordCountingFilter(final IPipeReceiver receiver) {
		super(receiver, 16, 64, "Methodcalls/sec");
		counter.setEnabled(false);
	}

	@Override
	public void processRecord(final IRecord record) {
		if (record instanceof Trace) {
			final Trace trace = (Trace) record;
			for (final AbstractEventRecord event : trace.getTraceEvents()) {
				if (event instanceof AbstractBeforeEventRecord) {
					final AbstractBeforeEventRecord abstractBeforeEventRecord = (AbstractBeforeEventRecord) event;
					counter.inputObjectsCount(abstractBeforeEventRecord
							.getRuntimeStatisticInformation().getCount());
				}
			}
		} else if (record instanceof AbstractBeforeEventRecord) {
			counter.inputObjectsCount(1);
		} else {
			deliver(record);
		}
	}
}
